//favModels = [];

function PreferencesAssistant(argFromPusher) {
	this.mainScene = argFromPusher.scene;
	this.mensen = argFromPusher.mensen
	this.prefs = argFromPusher.prefs
	this.db = argFromPusher.db;
	
	this.favModels = [];
}

PreferencesAssistant.prototype.isEmpty = function(variable) {
	for(var v in variable) {return false};
	return true;
},


PreferencesAssistant.prototype.setup = function() {
	
	while (this.prefs.favorites.length < 3) {
			this.prefs.favorites.push({});
			Mojo.Log.info("Fill");
	}
	
	// Remove app menu
    this.controller.setupWidget(Mojo.Menu.appMenu, 
		this.menuAttribute = {
			omitDefaultItems: true
		},
		{}
    );
    
    // define choices for mode selection
	this.modeChoices = [{label:$L('Alle'), value:"ALL"},
	                    {label:$L('Favoriten'), value:"FAV"}];
	
	// read from prefs to set the right mode
	if (this.prefs.showAll) {
		this.modeModel = {value : "ALL"};
		this.favsDisabled = true;
	} else {
		this.modeModel = {value : "FAV"};
		this.favsDisabled = false;
	}
	
// TODO: Implement whole list selection	
//	this.controller.setupWidget('ModeSelector', 
//		{
//			label: $L('Anzeigen'),
//			choices: this.modeChoices,
//		}, 
//		this.modeModel
//	);
//	
//	Mojo.Event.listen(this.controller.get("ModeSelector"), Mojo.Event.propertyChange, this.handleModeUpdate.bind(this));

	// define choices for favorite selectors
	this.generalChoices = [];
	for (i=0; i < this.mensen.length; i++) {
		this.generalChoices.push({label:$L(this.mensen[i].title), value: this.mensen[i].short});
	}
	
	this.extendedChoices = [{label:$L("Aus"), value: "OFF"}];
	this.extendedChoices = this.extendedChoices.concat(this.generalChoices);

	// read model values from prefs
	this.favModels = [];
	for (i=0; i < this.prefs.favorites.length; i++) {
		if (!this.isEmpty(this.prefs.favorites[i])) {
			this.favModels.push({value: this.prefs.favorites[i].short});
		} else {
			this.favModels.push({value: "OFF"});
		}
	}
	
	this.favChoices = [];
	this.favChoices.push(this.generalChoices);
	if (this.favModels[2].value == "OFF") {
		this.favChoices.push(this.extendedChoices);
	} else {
		this.favChoices.push(this.generalChoices);
	}
	
	this.favChoices.push(this.extendedChoices);
	
	this.controller.setupWidget('Fav1Selector', 
		{
			label: $L('Favorit 1'),
			choices: this.favChoices[0],
		}, 
		this.favModels[0]
	);
	this.controller.setupWidget('Fav2Selector', 
		this.fav2attributes = {
			label: $L('Favorit 2'),
			choices: this.favChoices[1],
		}, 
		this.favModels[1]
	);
	this.controller.setupWidget('Fav3Selector', 
		{
			label: $L('Favorit 3'),
			choices: this.favChoices[2],
		}, 
		this.favModels[2]
	);
	
	Mojo.Event.listen(this.controller.get("Fav1Selector"), Mojo.Event.propertyChange, this.handleFav1Update.bind(this));
	Mojo.Event.listen(this.controller.get("Fav2Selector"), Mojo.Event.propertyChange, this.handleFav2Update.bind(this));
	Mojo.Event.listen(this.controller.get("Fav3Selector"), Mojo.Event.propertyChange, this.handleFav3Update.bind(this));
};

PreferencesAssistant.prototype.handleModeUpdate = function(event) {
	// Update Preferences GUI
	if (event.value == "FAV") {
		this.favModels[0].disabled = false;
		this.favModels[1].disabled = false;
		this.favModels[2].disabled = false;
		this.prefs.showAll = false;
	} else {
		this.favModels[0].disabled = true;
		this.favModels[1].disabled = true;
		this.favModels[2].disabled = true;
		this.prefs.showAll = true;
	}
	
	this.controller.modelChanged(this.favModels[0]);
	this.controller.modelChanged(this.favModels[1]);
	this.controller.modelChanged(this.favModels[2]);

	// Update Preferences DB Entry
	this.db.add('Preferences', this.prefs, 
			function() {Mojo.Log.info('handleModeUpdate: stored Preferences');},
	    	function() {Mojo.Log.error('handleModeUpdate: storing Preferences failed');});
	
	// Update Main Window Controls
	this.mainScene.setupControlMenu(this.prefs);
	
	// TODO Update Main Window List
};

PreferencesAssistant.prototype.handleFav1Update = function(event) {
	if (event.value == "OFF") {
		this.prefs.favorites[0] = {};
	} else {
		i = 0;
		while (i < this.mensen.length && this.mensen[i].short != event.value) {
			i++;
		}
		this.prefs.favorites[0] = this.mensen[i];
		this.mainScene.loadMeals(this.prefs);
	}
	
	// Update Preferences DB Entry
	this.db.add('Preferences', this.prefs, 
			function() {Mojo.Log.info('handleFav1Update: stored Preferences');},
	    	function() {Mojo.Log.error('handleFav1Update: storing Preferences failed');});
	
	// Update Main Window Controls
	this.mainScene.setupControlMenu(this.prefs);
	
	this.mainScene.currentMensa = this.prefs.favorites[0].title;
	this.db.get(this.prefs.favorites[0].title, this.mainScene.dbGetMensaOK.bind(this.mainScene), this.mainScene.dbGetMensaFail.bind(this.mainScene));
}

PreferencesAssistant.prototype.handleFav2Update = function(event) {
	if (event.value == "OFF") {
		this.prefs.favorites[1] = {};
	} else {
		i = 0;
		while (i < this.mensen.length && this.mensen[i].short != event.value) {
			i++;
		}
		this.prefs.favorites[1] = this.mensen[i];
		this.mainScene.loadMeals(this.prefs);
	}
	
	// Update Preferences DB Entry
	this.db.add('Preferences', this.prefs, 
			function() {Mojo.Log.info('handleFav2Update: stored Preferences');},
	    	function() {Mojo.Log.error('handleFav2Update: storing Preferences failed');});
	
	// Update Main Window GUI
	this.mainScene.setupControlMenu(this.prefs);

	this.mainScene.currentMensa = this.prefs.favorites[0].title;
	this.db.get(this.prefs.favorites[0].title, this.mainScene.dbGetMensaOK.bind(this.mainScene), this.mainScene.dbGetMensaFail.bind(this.mainScene));
}

PreferencesAssistant.prototype.handleFav3Update = function(event) {
	if (event.value == "OFF") {
		this.prefs.favorites[2] = {};
		this.fav2attributes.choices = this.extendedChoices;
	} else {
		i = 0;
		while (i < this.mensen.length && this.mensen[i].short != event.value) {
			i++;
		}
		this.prefs.favorites[2] = this.mensen[i];
		
		this.fav2attributes.choices = this.generalChoices; // remove empty option from favselector 2
		this.mainScene.loadMeals(this.prefs);
	}
	
	this.controller.modelChanged(this.favModels[1]);
	
	// Update Preferences DB Entry
	this.db.add('Preferences', this.prefs, 
			function() {Mojo.Log.info('handleFav3Update: stored Preferences');},
	    	function() {Mojo.Log.error('handleFav3Update: storing Preferences failed');});
	
	// Update Main Window Controls
	this.mainScene.setupControlMenu(this.prefs);
	
	this.mainScene.currentMensa = this.prefs.favorites[0].title;
	this.db.get(this.prefs.favorites[0].title, this.mainScene.dbGetMensaOK.bind(this.mainScene), this.mainScene.dbGetMensaFail.bind(this.mainScene));
}

PreferencesAssistant.prototype.activate = function(event) {
	/* put in event handlers here that should only be in effect when this scene is active. For
	   example, key handlers that are observing the document */
};

PreferencesAssistant.prototype.deactivate = function(event) {
	/* remove any event handlers you added in activate and do any other cleanup that should happen before
	   this scene is popped or another scene is pushed on top */
};

PreferencesAssistant.prototype.cleanup = function(event) {
	/* this function should do any cleanup needed before the scene is destroyed as 
	   a result of being popped off the scene stack */
};
