var SimpleAssistant = function() {
	this.mensen = [{title: "Hauptmensa", url: "http://www.studentenwerk-hannover.de/menues.php?wo=2&wann=2&textausgabe=1", short: "HM"},
	               {title: "Marktstand", url: "http://www.studentenwerk-hannover.de/menues.php?wo=9&wann=2&textausgabe=1", short: "MS"},
	               {title: "Contine", url: "http://www.studentenwerk-hannover.de/menues.php?wo=3&wann=2&textausgabe=1", short: "Con"},
	               {title: "Mensa PZH", url: "http://www.studentenwerk-hannover.de/menues.php?wo=13&wann=2&textausgabe=1", short: "PZH"},
	               {title: "Mensa Caballus", url: "http://www.studentenwerk-hannover.de/menues.php?wo=1&wann=2&textausgabe=1", short: "Cab"},
	               {title: "Mensa TiHo Tower", url: "http://www.studentenwerk-hannover.de/menues.php?wo=0&wann=2&textausgabe=1", short: "TiHo"},
	               {title: "Mensa HMTMH", url: "http://www.studentenwerk-hannover.de/menues.php?wo=8&wann=2&textausgabe=1", short: "HMTM"},
	               {title: "Mensa FHH", url: "http://www.studentenwerk-hannover.de/menues.php?wo=5&wann=2&textausgabe=1", short: "FH"},
	               {title: "Mensa Kurt-Schwitters-Forum", url: "http://www.studentenwerk-hannover.de/menues.php?wo=7&wann=2&textausgabe=1", short: "KSF"},
	               {title: "Mensa Blumhardtstrasse", url: "http://www.studentenwerk-hannover.de/menues.php?wo=14&wann=2&textausgabe=1", short: "Blu"},
	               {title: "Cafeteria Sprengelstube", url: "http://www.studentenwerk-hannover.de/menues.php?wo=15&wann=2&textausgabe=1", short: "CS"},
	               {title: "Cafeteria Herrenhausen", url: "http://www.studentenwerk-hannover.de/menues.php?wo=12&wann=2&textausgabe=1", short: "CH"}];
};



var mainMenu;
var marketMenu;

//var db;

foundMenusMon = [];
foundMenusTue = [];
foundMenusWed = [];
foundMenusThu = [];
foundMenusFri = [];

var listModelMon = {listTitle:$L('Speiseplan - Montag'), items:foundMenusMon};
var listModelTue = {listTitle:$L('Speiseplan - Dienstag'), items:foundMenusTue};
var listModelWed = {listTitle:$L('Speiseplan - Mittwoch'), items:foundMenusWed};
var listModelThu = {listTitle:$L('Speiseplan - Donnerstag'), items:foundMenusThu};
var listModelFri = {listTitle:$L('Speiseplan - Freitag'), items:foundMenusFri};

var currentMensa;

SimpleAssistant.prototype = {
	isEmpty: function(variable) {
		for(var v in variable) {return false};
		return true;
	},
	
    setup: function() {
    	this.controller.setupWidget("scrollerId", {
                   mode: 'horizontal-snap',
               }, this.model = {
                   snapElements: { x: $$('.scrollerItem') },
                   snapIndex: 0,
               }
        );
    	
        this.controller.setupWidget(Mojo.Menu.appMenu, 
        		this.menuAttribute = {
        			omitDefaultItems: true
        		}, 
        		this.menuModel = {
        			visible: true,
        			items: [
        				{
        					label: "Einstellungen",
        					command: 'do-prefs'
        				},
        				{
        					label: "Hilfe",
        					command: 'do-help'
        				}
        			]
        		}
        );
        
        this.controller.setupWidget("spinnerId", {}, {spinning: false});
        
	    this.controllerModel = {visible: false, items: [{}, {}, {}]};
        this.controller.setupWidget(Mojo.Menu.commandMenu, {}, this.controllerModel);	
        
        this.db = new Mojo.Depot({ name: 'mensaplanHannoverDB' }, 
        	function() {Mojo.Log.info('create success');},
      		function() {Mojo.Log.error('create fail');});

		this.controller.setupWidget("menuListMon", this.attributes = {
			itemTemplate: 'simple/static-list-entry',
			listTemplate: 'simple/static-list-container',
			emptyTemplate: 'simple/emptylist',
		}, listModelMon);
		this.controller.setupWidget("menuListTue", this.attributes = {
			itemTemplate: 'simple/static-list-entry',
			listTemplate: 'simple/static-list-container',
			emptyTemplate: 'simple/emptylist'
		}, listModelTue);
		this.controller.setupWidget("menuListWed", this.attributes = {
			itemTemplate: 'simple/static-list-entry',
			listTemplate: 'simple/static-list-container',
			emptyTemplate: 'simple/emptylist'
		}, listModelWed);
		this.controller.setupWidget("menuListThu", this.attributes = {
			itemTemplate: 'simple/static-list-entry',
			listTemplate: 'simple/static-list-container',
			emptyTemplate: 'simple/emptylist'
		}, listModelThu);
		this.controller.setupWidget("menuListFri", this.attributes = {
			itemTemplate: 'simple/static-list-entry',
			listTemplate: 'simple/static-list-container',
			emptyTemplate: 'simple/emptylist'
		}, listModelFri);

	    this.controller.listen("scrollerId", Mojo.Event.scrollStarting, this.handleUpdate.bindAsEventListener(this));
	    
	    this.db.get('Preferences', this.dbGetPreferencesOK.bind(this), this.dbGetPreferencesFail.bind(this));
	    
	    this.scrolled = false;
		
		//~ set default language
		this.language  = "de"
		//~ update language with system settings
		this.controller.serviceRequest("palm://com.palm.systemservice", {
			method: "getPreferences",
			parameters: {
				"keys": ["locale"]
			},
			onSuccess: this.languageGetOK.bind(this),
			onFailure: function() {},
		});
		//~ this.apiKey = "AIzaSyCZC3V7g0najnS-CxWNFyScqrOLlYXxjBQ"; //~ production
		//~ this.apiKey = "AIzaSyCVvMfDu-_Iv200_pu_wYXMzPfPGCtPWAo"; //~ testing
		this.apiKey = "AIzaSyCDTSIjQ84OKf5GYDtC1QsrjUQL0dJ1AI4";
    },
    
    handleMoved: function(done, position) {
        if (done) Mojo.Log.info("Done: ", done, "Position: ", Object.toJSON(position));
    },

    handleUpdate: function(event) {
        event.addListener({                                                    
                moved: this.handleMoved                         
        });
    },
    
    activate: function(event) {},
    deactivate: function(event) {},
    cleanup: function(event) {}
}

SimpleAssistant.prototype.languageGetOK = function(data) {
	Mojo.Log.info("requestSuccess: " + data["locale"]["languageCode"]);
	this.language = data["locale"]["languageCode"];
}

SimpleAssistant.prototype.dbGetPreferencesOK = function(prefs) {
	if (prefs == null || prefs == "") {
		this.prefs = { showAll: false, favorites: [this.mensen[0], this.mensen[1], {}] };
		this.db.add('Preferences', this.prefs, 
				function() {Mojo.Log.info('dbGetPreferencesOK: stored Preferences');},
		    	function() {Mojo.Log.error('dbGetPreferencesOK: Storing Preferences failed');});
	} else {
		this.prefs = prefs;
	}
	
	this.setupControlMenu(this.prefs);
	this.loadMeals(this.prefs);
	this.currentMensa = this.prefs.favorites[0].title;
	this.db.get(this.currentMensa, this.dbGetMensaOK.bind(this), this.dbGetMensaFail.bind(this));
};

SimpleAssistant.prototype.dbGetPreferencesFail = function() {
	this.prefs = { showAll: false, favorites: [this.mensen[0], this.mensen[1], {}] };
	this.db.add('Preferences', prefs, 
			function() {Mojo.Log.info('dbGetPreferencesOK: stored Preferences');},
	    	function() {Mojo.Log.error('dbGetPreferencesOK: Storing Preferences failed');});
	setupControlMenu(this.prefs);
	this.loadMeals(this.prefs);
}

SimpleAssistant.prototype.dbGetMensaOK = function(models) {
	if (models != null && models != "") {
		listModelMon.listTitle = models[0].listTitle;
		listModelMon.items = models[0].items;
		listModelTue.listTitle = models[1].listTitle;
		listModelTue.items = models[1].items;
		listModelWed.listTitle = models[2].listTitle;
		listModelWed.items = models[2].items;
		listModelThu.listTitle = models[3].listTitle;
		listModelThu.items = models[3].items;
		listModelFri.listTitle = models[4].listTitle;
		listModelFri.items = models[4].items;
		
		this.controller.modelChanged(listModelMon);
		this.controller.modelChanged(listModelTue);
		this.controller.modelChanged(listModelWed);
		this.controller.modelChanged(listModelThu);
		this.controller.modelChanged(listModelFri);
		
		if (!this.scrolled) {
		    var myDate=new Date();
			var snapIndex = Math.min(4, Math.max(0, myDate.getDay() - 1));
			
			var scroller = this.controller.get('scrollerId');
			scroller.mojo.setSnapIndex(snapIndex, false);
			this.scrolled = true;
		}
	}
};

SimpleAssistant.prototype.dbGetMensaFail = function() {
}

SimpleAssistant.prototype.setupControlMenu = function(prefs) {
	if (prefs.showAll) {
		this.controllerModel.visible = true;
		this.controllerModel.items = [{}, {}, {
            items: [{
                command: 'do-pick',
                label: "Wähle"
            }]
        }];
	} else {
		this.controllerModel.visible = true,
		
		items = [];
		for (i=0; i<prefs.favorites.length; i++) {
			if (!this.isEmpty(prefs.favorites[i])) {
				items.push({command: "do-m" + (i+1), label: prefs.favorites[i].short});
			}
		}
		
		if (items.length > 1) {
			this.controllerModel.items = [{}, {}, {
	        	toggleCmd: items[0].command,
	            items: items
	        }];
		} else {
			this.controllerModel.items = [{}, {}, {}];
		}
	}
	
	this.controller.modelChanged(this.controllerModel);
}

SimpleAssistant.prototype.loadMeals = function(prefs) {
	this.controller.get("spinnerId").mojo.start();
	this.mealList = [];
	if (prefs.showAll == true) {
		for (i=0; i<this.mensen.length; i++) {
			this.mealList.push(this.mensen[i]);
		}
	} else {
		for (i=0; i<prefs.favorites.length; i++) {
			this.mealList.push(prefs.favorites[i]);
		}
	}
	
	for (i = this.mealList.length-1; i>=0; i--) {
		if (this.isEmpty(this.mealList[i])) {
			this.mealList.splice(i, 1);
		}
	}
	

	if (this.mealList.length > 0) {
		//this.currentMensa = this.mealList[0].title;
		var request = new Ajax.Request(this.mealList[0].url, {
			method: 'get',
			evalJSON: 'false',
			onSuccess: this.translateRequest.bind(this),
			onFailure: this.requestFailure.bind(this)
		});
	}
}

SimpleAssistant.prototype.translateRequest = function(transport) {
	if (this.language != "de") {
		Mojo.Log.info("Translate menu to: " + this.language);
		var text = transport.responseText;
		Mojo.Log.info("LENGTH: " + text.length);
		var url = "https://www.googleapis.com/language/translate/v2"
		var request = new Ajax.Request(url, {
			method: "post",
			evalJSON: "False",
			parameters: {
				"key": this.apiKey,
				"source": "de",
				"target": this.language,
				"q": text
			},
			requestHeaders: {
				"X-HTTP-Method-Override": "GET",
			},
			onSuccess: this.translateRequestOK.bind(this, transport),
			onFailure: this.translateRequestFail.bind(this, transport)
		});
	} else {
		this.requestSuccess(transport);
	};
};

SimpleAssistant.prototype.translateRequestOK = function(originalTransport, data) {
	var result = {
		"responseText": data.responseJSON["data"]["translations"][0]["translatedText"].replace(/&gt;/g, "\n>"),
	}
	this.requestSuccess(result);
};

SimpleAssistant.prototype.translateRequestFail = function(originalTransport, error) {
	var e = error.responseJSON["error"];
	Mojo.Log.info("Could not translate menu, reason: " + e.message + " (" + e.code + ")");
	Mojo.Log.info("Could not translate menu, reason: " +error.responseText);
	this.requestSuccess(originalTransport);
};

SimpleAssistant.prototype.requestFailure = function(transport) {
	Mojo.Controller.errorDialog("Das Studentenwerk stellt derzeit keine Daten zur Verfügung oder die Verbindung zum Server ist gestört.");
};

SimpleAssistant.prototype.requestSuccess = function(transport) {
	Mojo.Log.info("requestSuccess: " + this.mealList[0].title);
	switch (this.mealList[0].title) {
	case "Hauptmensa":
		this.parseHauptmensa(transport.responseText);
		break;
	case "Marktstand":
		this.parseMarktstand(transport.responseText);
		break;
	case "Contine":
		this.parseContine(transport.responseText);
		break;
	case "Mensa PZH":
		this.parsePZH(transport.responseText);
		break;
	case "Mensa Caballus":
		this.parseCaballus(transport.responseText);
		break;
	case "Mensa TiHo Tower":
		this.parseTiHo(transport.responseText);
		break;
	case "Mensa HMTMH":
		this.parseHMTMH(transport.responseText);
		break;
	case "Mensa FHH":
		this.parseFHH(transport.responseText);
		break;
	case "Mensa Kurt-Schwitters-Forum":
		this.parseKSF(transport.responseText);
		break;
	case "Mensa Blumhardtstrasse":
		this.parseBlumhardt(transport.responseText);
		break;
	case "Cafeteria Sprengelstube":
		this.parseSprengel(transport.responseText);
		break;
	case "Cafeteria Herrenhausen":
		this.parseHerrenhausen(transport.responseText);
		break;	
	}
	
	this.mealList.splice(0, 1);
	if (this.mealList.length > 0) {
		Mojo.Log.info("requestSuccess: Requesting " + this.mealList[0].title)
		var request = new Ajax.Request(this.mealList[0].url, {
			method: 'get',
			evalJSON: 'false',
			onSuccess: this.translateRequest.bind(this),
			onFailure: this.requestFailure.bind(this)
		});
	} else {
		this.controller.get("spinnerId").mojo.stop();
	}
}

SimpleAssistant.prototype.handleCommand = function(event) {
 
    switch(event.type) {
        case Mojo.Event.command:
            switch (event.command) {
            	case 'do-prefs':
            		this.controller.stageController.pushScene('preferences', {scene: this, mensen: this.mensen, prefs: this.prefs, db: this.db});
            		break;
            	
            	case 'do-help':
            		model = { 
            				title: "Mensaplan Hannover - v" + Mojo.Controller.appInfo.version,
            				allowHTMLMessage: true,
            				message: "Mensaplan für die Universität Hannover. " +
            					"Mit freundlicher Unterstützung vom Studentenwerk Hannover.<br><br>"+
            					"Support: <a href=\"mailto:hurling83@googlemail.com\">hurling83@googlemail.com</a>",
            				choices: []
            		};
            		this.controller.showAlertDialog(model);
            		break;
            		
                case 'do-m1':
                	this.db.get(this.prefs.favorites[0].title, this.dbGetMensaOK.bind(this), this.dbGetMensaFail.bind(this));
                	this.currentMensa = this.prefs.favorites[0].title;
        			break;
        			
      			case 'do-m2':
        			this.db.get(this.prefs.favorites[1].title, this.dbGetMensaOK.bind(this), this.dbGetMensaFail.bind(this));
        			this.currentMensa = this.prefs.favorites[1].title;
        			break;
        			
      			case 'do-m3':
      				this.db.get(this.prefs.favorites[2].title, this.dbGetMensaOK.bind(this), this.dbGetMensaFail.bind(this));
      				this.currentMensa = this.prefs.favorites[2].title;
      				break;      				
            }
        break;
    }
};







//--------------------------------------------------
//This part is responsible for parsing the responses
//--------------------------------------------------

SimpleAssistant.prototype.parseResponse = function(responseText) {
	if (responseText != null && responseText != "") {
		menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
		menu = menu.split(/#/g);
		
		// parse list titles from string
		titles = [
		           $L('Montag -' + menu[1].substring(3)),
		           $L('Dienstag -' + menu[3].substring(3)),
		           $L('Mittwoch -' + menu[5].substring(3)),
		           $L('Donnerstag -' + menu[7].substring(3)),
		           $L('Freitag -' + menu[9].substring(3))
		         ];

		// parse list items from string
		menus = [menu[2].split(/>|\|/g),
		         menu[4].split(/>|\|/g),
		         menu[6].split(/>|\|/g),
		         menu[8].split(/>|\|/g),
		         menu[10].split(/>|\|/g)];
		
		// switch between cafeterias
		
		// stuff together list models
	}
}

SimpleAssistant.prototype.parseListTitles = function(menu) {
	titles = [$L('Montag -' + menu[1].substring(3)),
	          $L('Dienstag -' + menu[3].substring(3)),
	          $L('Mittwoch -' + menu[5].substring(3)),
	          $L('Donnerstag -' + menu[7].substring(3)),
	          $L('Freitag -' + menu[9].substring(3))];
	
	return titles;
}

SimpleAssistant.prototype.parseHauptmensa = function(menu) {
	menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
	menu = menu.split(/#/g);
	
	// parse list titles from string
	titles = this.parseListTitles(menu);
	
	// parse list items from string
	menus = [menu[2].split(/>|\|/g),
	         menu[4].split(/>|\|/g),
	         menu[6].split(/>|\|/g),
	         menu[8].split(/>|\|/g),
	         menu[10].split(/>|\|/g)];
	
	// for each list item we need to fill the header and the menu part
	for (i = 0; i < 5; i++) {
		menus[i] = [
	     			{header:$L("Tellergericht"), menu:$L(menus[i][2].split(": ")[1])},
	     			{header:$L("Bio-Line"), menu:$L(menus[i][3].split(": ")[1])},
	     			{header:$L("Wahlmenü (Fleisch)"), menu:$L(menus[i][5].split(": ")[1])},
	     			{header:$L("Wahlmenü (vegetarisch)"), menu:$L(menus[i][6].split(": ")[1])},
	     			{header:$L("Beilagen/Dessert"), menu:$L(menus[i][7].split(": ")[1] + "<br>" + menus[i][8].split(": ")[1] + "<br>" + menus[i][9].split(": ")[1] + "<br>" + menus[i][10].split(": ")[1])},
	     			{header:$L("Eintopf"), menu:$L(menus[i][1].split(": ")[1])},
	     		];
	}

	// stuff together list models
	listModels = [
	              {listTitle:titles[0], items:menus[0]},
	              {listTitle:titles[1], items:menus[1]},
	              {listTitle:titles[2], items:menus[2]},
	              {listTitle:titles[3], items:menus[3]},
	              {listTitle:titles[4], items:menus[4]}
	             ];
	
	// now I can save all these models to the db and update the screen
	this.db.add('Hauptmensa', listModels, 
			function() {Mojo.Log.info('parseHauptmensa: stored menu');},
	    	function() {Mojo.Log.error('parseHauptmensa: storing menu failed');});
	
	if (this.currentMensa == "Hauptmensa")
		this.dbGetMensaOK(listModels);
	
}

SimpleAssistant.prototype.parseMarktstand = function(menu) {
	menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
	menu = menu.split(/#/g);
	
	// parse list titles from string
	titles = this.parseListTitles(menu);

	// parse list items from string
	menus = [menu[2].split(/>|\|/g),
	         menu[4].split(/>|\|/g),
	         menu[6].split(/>|\|/g),
	         menu[8].split(/>|\|/g),
	         menu[10].split(/>|\|/g)];
	
	// for each list item we need to fill the header and the menu part
	for (i = 0; i < 5; i++) {
		menus[i] = [
					{header:$L("Tortilla / Pizza"), menu:$L(menus[i][1].split(": ")[1])},
					{header:$L("Auflauf"), menu:$L(menus[i][2].split(": ")[1])},
					{header:$L("Pfannengericht"), menu:$L(menus[i][3].split(": ")[1])},
					{header:$L("Steak mit Beilagen"), menu:$L(menus[i][4].split(": ")[1])},
	     		];
	}
	

	// stuff together list models
	listModels = [
	              {listTitle:titles[0], items:menus[0]},
	              {listTitle:titles[1], items:menus[1]},
	              {listTitle:titles[2], items:menus[2]},
	              {listTitle:titles[3], items:menus[3]},
	              {listTitle:titles[4], items:menus[4]}
	             ];
	
	// now I can save all these models to the db and update the screen
	this.db.add('Marktstand', listModels, 
			function() {Mojo.Log.info('parseMarktstand: stored  menu');},
	    	function() {Mojo.Log.error('parseMarktstand: storing menu failed');});
	
	if (this.currentMensa == "Marktstand")
		this.dbGetMensaOK(listModels);
}

SimpleAssistant.prototype.parseContine = function(menu) {
	menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
	menu = menu.split(/#/g);
	
	// parse list titles from string
	titles = this.parseListTitles(menu);

	// parse list items from string
	menus = [menu[2].split(/>|\|/g),
	         menu[4].split(/>|\|/g),
	         menu[6].split(/>|\|/g),
	         menu[8].split(/>|\|/g),
	         menu[10].split(/>|\|/g)];
	
	// for each list item we need to fill the header and the menu part
	for (i = 0; i < 5; i++) {
		menus[i] = [
					{header:$L("Schneller Teller"), menu:$L(menus[i][2].split(": ")[1])},
					{header:$L("Wahlmenü (Fleisch)"), menu:$L(menus[i][4].split(": ")[1])},
					{header:$L("Wahlmenü (vegetarisch)"), menu:$L(menus[i][5].split(": ")[1])},
					{header:$L("Beilagen/Dessert"), menu:$L(menus[i][6].split(": ")[1] + "<br>" + menus[i][7].split(": ")[1] + "<br>" + menus[i][8].split(": ")[1] + "<br>" + menus[i][9].split(": ")[1])},
					{header:$L("Eintopf"), menu:$L(menus[i][1].split(": ")[1])},
					{header:$L("Conti-Counter"), menu:$L(menus[i][10].split(": ")[1])}
	     		];
	}
	

	// stuff together list models
	listModels = [
	              {listTitle:titles[0], items:menus[0]},
	              {listTitle:titles[1], items:menus[1]},
	              {listTitle:titles[2], items:menus[2]},
	              {listTitle:titles[3], items:menus[3]},
	              {listTitle:titles[4], items:menus[4]}
	             ];
	
	// now I can save all these models to the db and update the screen
	this.db.add('Contine', listModels, 
			function() {Mojo.Log.info('parseContine: stored menu');},
	    	function() {Mojo.Log.error('parseContine: storing menu failed');});
	
	if (this.currentMensa == "Contine")
		this.dbGetMensaOK(listModels);
}

SimpleAssistant.prototype.parsePZH = function(menu) {
	menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
	menu = menu.split(/#/g);
	
	// parse list titles from string
	titles = this.parseListTitles(menu);

	// parse list items from string
	menus = [menu[2].split(/>|\|/g),
	         menu[4].split(/>|\|/g),
	         menu[6].split(/>|\|/g),
	         menu[8].split(/>|\|/g),
	         menu[10].split(/>|\|/g)];
	
	// for each list item we need to fill the header and the menu part
	for (i = 0; i < 5; i++) {
		menus[i] = [
					{header:$L("Eintopf/Tellergericht"), menu:$L(menus[i][1].split(": ")[1])},
					{header:$L("Menü"), menu:$L(menus[i][2].split(": ")[1])},
					{header:$L("Menü fleischlos"), menu:$L(menus[i][3].split(": ")[1])}
	     		];
	}
	

	// stuff together list models
	listModels = [
	              {listTitle:titles[0], items:menus[0]},
	              {listTitle:titles[1], items:menus[1]},
	              {listTitle:titles[2], items:menus[2]},
	              {listTitle:titles[3], items:menus[3]},
	              {listTitle:titles[4], items:menus[4]}
	             ];
	
	// now I can save all these models to the db and update the screen
	this.db.add('Mensa PZH', listModels, 
			function() {Mojo.Log.info('parsePZH: stored menu');},
	    	function() {Mojo.Log.error('parsePZH: storing menu failed');});
	
	if (this.currentMensa == "Mensa PZH")
		this.dbGetMensaOK(listModels);
}

SimpleAssistant.prototype.parseCaballus = function(menu) {
	menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
	menu = menu.split(/#/g);
	
	// parse list titles from string
	titles = this.parseListTitles(menu);

	// parse list items from string
	menus = [menu[2].split(/>|\|/g),
	         menu[4].split(/>|\|/g),
	         menu[6].split(/>|\|/g),
	         menu[8].split(/>|\|/g),
	         menu[10].split(/>|\|/g)];
	
	// for each list item we need to fill the header and the menu part
	for (i = 0; i < 5; i++) {
		menus[i] = [
					{header:$L("Eintopf"), menu:$L(menus[i][1].split(": ")[1])},
					{header:$L("Tellergericht"), menu:$L(menus[i][2].split(": ")[1])},
					{header:$L("Wahlmenü (Fleisch)"), menu:$L(menus[i][4].split(": ")[1])},
					{header:$L("Wahlmenü (vegetarisch)"), menu:$L(menus[i][5].split(": ")[1])},
					{header:$L("Beilagen/Dessert"), menu:$L(menus[i][6].split(": ")[1] + "<br>" + menus[i][7].split(": ")[1] + "<br>" + menus[i][8].split(": ")[1] + "<br>" + menus[i][9].split(": ")[1])}
	     		];
	}
	

	// stuff together list models
	listModels = [
	              {listTitle:titles[0], items:menus[0]},
	              {listTitle:titles[1], items:menus[1]},
	              {listTitle:titles[2], items:menus[2]},
	              {listTitle:titles[3], items:menus[3]},
	              {listTitle:titles[4], items:menus[4]}
	             ];
	
	// now I can save all these models to the db and update the screen
	this.db.add('Mensa Caballus', listModels, 
			function() {Mojo.Log.info('parseContine: stored menu');},
	    	function() {Mojo.Log.error('parseContine: storing menu failed');});
	
	if (this.currentMensa == "Mensa Caballus")
		this.dbGetMensaOK(listModels);	
}

SimpleAssistant.prototype.parseTiHo = function(menu) {
	menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
	menu = menu.split(/#/g);
	
	// parse list titles from string
	titles = this.parseListTitles(menu);

	// parse list items from string
	menus = [menu[2].split(/>|\|/g),
	         menu[4].split(/>|\|/g),
	         menu[6].split(/>|\|/g),
	         menu[8].split(/>|\|/g),
	         menu[10].split(/>|\|/g)];
	
	// for each list item we need to fill the header and the menu part
	for (i = 0; i < 5; i++) {
		menus[i] = [
					{header:$L("Eintopf"), menu:$L(menus[i][1].split(": ")[1])},
					{header:$L("Tellergericht"), menu:$L(menus[i][2].split(": ")[1])},
					{header:$L("Wahlmenü (Fleisch)"), menu:$L(menus[i][4].split(": ")[1])},
					{header:$L("Wahlmenü (vegetarisch)"), menu:$L(menus[i][5].split(": ")[1])},
					{header:$L("Beilagen/Dessert"), menu:$L(menus[i][6].split(": ")[1] + "<br>" + menus[i][7].split(": ")[1] + "<br>" + menus[i][8].split(": ")[1] + "<br>" + menus[i][9].split(": ")[1])}
	     		];
	}
	

	// stuff together list models
	listModels = [
	              {listTitle:titles[0], items:menus[0]},
	              {listTitle:titles[1], items:menus[1]},
	              {listTitle:titles[2], items:menus[2]},
	              {listTitle:titles[3], items:menus[3]},
	              {listTitle:titles[4], items:menus[4]}
	             ];
	
	// now I can save all these models to the db and update the screen
	this.db.add('Mensa TiHo Tower', listModels, 
			function() {Mojo.Log.info('parseContine: stored menu');},
	    	function() {Mojo.Log.error('parseContine: storing menu failed');});
	
	if (this.currentMensa == "Mensa TiHo Tower")
		this.dbGetMensaOK(listModels);		
}

SimpleAssistant.prototype.parseHMTMH = function(menu) {
	menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
	menu = menu.split(/#/g);
	
	// parse list titles from string
	titles = this.parseListTitles(menu);

	// parse list items from string
	menus = [menu[2].split(/>|\|/g),
	         menu[4].split(/>|\|/g),
	         menu[6].split(/>|\|/g),
	         menu[8].split(/>|\|/g),
	         menu[10].split(/>|\|/g)];
	
	// for each list item we need to fill the header and the menu part
	for (i = 0; i < 5; i++) {
		menus[i] = [
					{header:$L("Eintopf"), menu:$L(menus[i][1].split(": ")[1])},
					{header:$L("Tellergericht"), menu:$L(menus[i][2].split(": ")[1])},
					{header:$L("Menü"), menu:$L(menus[i][3].split(": ")[1])},
					{header:$L("Menü fleischlos"), menu:$L(menus[i][4].split(": ")[1])}
	     		];
	}
	

	// stuff together list models
	listModels = [
	              {listTitle:titles[0], items:menus[0]},
	              {listTitle:titles[1], items:menus[1]},
	              {listTitle:titles[2], items:menus[2]},
	              {listTitle:titles[3], items:menus[3]},
	              {listTitle:titles[4], items:menus[4]}
	             ];
	
	// now I can save all these models to the db and update the screen
	this.db.add('Mensa HMTMH', listModels, 
			function() {Mojo.Log.info('parsePZH: stored menu');},
	    	function() {Mojo.Log.error('parsePZH: storing menu failed');});
	
	if (this.currentMensa == "Mensa HMTMH")
		this.dbGetMensaOK(listModels);
}

SimpleAssistant.prototype.parseFHH = function(menu) {
	menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
	menu = menu.split(/#/g);
	
	// parse list titles from string
	titles = this.parseListTitles(menu);

	// parse list items from string
	menus = [menu[2].split(/>|\|/g),
	         menu[4].split(/>|\|/g),
	         menu[6].split(/>|\|/g),
	         menu[8].split(/>|\|/g),
	         menu[10].split(/>|\|/g)];
	
	// for each list item we need to fill the header and the menu part
	for (i = 0; i < 5; i++) {
		menus[i] = [
					{header:$L("Eintopf/Tellergericht"), menu:$L(menus[i][1].split(": ")[1])},
					{header:$L("Wahlmenü (Fleisch)"), menu:$L(menus[i][3].split(": ")[1])},
					{header:$L("Wahlmenü (vegetarisch)"), menu:$L(menus[i][4].split(": ")[1])},
					{header:$L("Beilagen/Dessert"), menu:$L(menus[i][5].split(": ")[1] + "<br>" + menus[i][6].split(": ")[1] + "<br>" + menus[i][7].split(": ")[1] + "<br>" + menus[i][8].split(": ")[1])},
					{header:$L("Extras"), menu:$L(menus[i][9].split(": ")[1])}
	     		];
	}
	

	// stuff together list models
	listModels = [
	              {listTitle:titles[0], items:menus[0]},
	              {listTitle:titles[1], items:menus[1]},
	              {listTitle:titles[2], items:menus[2]},
	              {listTitle:titles[3], items:menus[3]},
	              {listTitle:titles[4], items:menus[4]}
	             ];
	
	// now I can save all these models to the db and update the screen
	this.db.add('Mensa FHH', listModels, 
			function() {Mojo.Log.info('parsePZH: stored menu');},
	    	function() {Mojo.Log.error('parsePZH: storing menu failed');});
	
	if (this.currentMensa == "Mensa FHH")
		this.dbGetMensaOK(listModels);	
}

SimpleAssistant.prototype.parseKSF = function(menu) {
	menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
	menu = menu.split(/#/g);
	
	// parse list titles from string
	titles = this.parseListTitles(menu);

	// parse list items from string
	menus = [menu[2].split(/>|\|/g),
	         menu[4].split(/>|\|/g),
	         menu[6].split(/>|\|/g),
	         menu[8].split(/>|\|/g),
	         menu[10].split(/>|\|/g)];
	
	// for each list item we need to fill the header and the menu part
	for (i = 0; i < 5; i++) {
		menus[i] = [
					{header:$L("Eintopf/Tellergericht"), menu:$L(menus[i][1].split(": ")[1])},
					{header:$L("Menü"), menu:$L(menus[i][2].split(": ")[1])},
					{header:$L("Menü fleischlos"), menu:$L(menus[i][3].split(": ")[1])}
	     		];
	}
	

	// stuff together list models
	listModels = [
	              {listTitle:titles[0], items:menus[0]},
	              {listTitle:titles[1], items:menus[1]},
	              {listTitle:titles[2], items:menus[2]},
	              {listTitle:titles[3], items:menus[3]},
	              {listTitle:titles[4], items:menus[4]}
	             ];
	
	// now I can save all these models to the db and update the screen
	this.db.add('Mensa Kurt-Schwitters-Forum', listModels, 
			function() {Mojo.Log.info('parsePZH: stored menu');},
	    	function() {Mojo.Log.error('parsePZH: storing menu failed');});
	
	if (this.currentMensa == "Mensa Kurt-Schwitters-Forum")
		this.dbGetMensaOK(listModels);		
}

SimpleAssistant.prototype.parseBlumhardt = function(menu) {
	menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
	menu = menu.split(/#/g);
	
	// parse list titles from string
	titles = this.parseListTitles(menu);

	// parse list items from string
	menus = [menu[2].split(/>|\|/g),
	         menu[4].split(/>|\|/g),
	         menu[6].split(/>|\|/g),
	         menu[8].split(/>|\|/g),
	         menu[10].split(/>|\|/g)];
	
	// for each list item we need to fill the header and the menu part
	for (i = 0; i < 5; i++) {
		menus[i] = [
					{header:$L("Eintopf/Tellergericht"), menu:$L(menus[i][1].split(": ")[1])},
					{header:$L("Menü"), menu:$L(menus[i][2].split(": ")[1])},
					{header:$L("Menü fleischlos"), menu:$L(menus[i][3].split(": ")[1])}
	     		];
	}
	

	// stuff together list models
	listModels = [
	              {listTitle:titles[0], items:menus[0]},
	              {listTitle:titles[1], items:menus[1]},
	              {listTitle:titles[2], items:menus[2]},
	              {listTitle:titles[3], items:menus[3]},
	              {listTitle:titles[4], items:menus[4]}
	             ];
	
	// now I can save all these models to the db and update the screen
	this.db.add('Mensa Blumhardtstrasse', listModels, 
			function() {Mojo.Log.info('parsePZH: stored menu');},
	    	function() {Mojo.Log.error('parsePZH: storing menu failed');});
	
	if (this.currentMensa == "Mensa Blumhardtstrasse")
		this.dbGetMensaOK(listModels);	
}

SimpleAssistant.prototype.parseSprengel = function(menu) {
	menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
	menu = menu.split(/#/g);
	
	// parse list titles from string
	titles = this.parseListTitles(menu);

	// parse list items from string
	menus = [menu[2].split(/>|\|/g),
	         menu[4].split(/>|\|/g),
	         menu[6].split(/>|\|/g),
	         menu[8].split(/>|\|/g),
	         menu[10].split(/>|\|/g)];
	
	// for each list item we need to fill the header and the menu part
	for (i = 0; i < 5; i++) {
		menus[i] = [
					{header:$L("Eintopf/Tellergericht"), menu:$L(menus[i][1].split(": ")[1])},
					{header:$L("Menü"), menu:$L(menus[i][2].split(": ")[1])},
					{header:$L("Menü fleischlos"), menu:$L(menus[i][3].split(": ")[1])}
	     		];
	}
	

	// stuff together list models
	listModels = [
	              {listTitle:titles[0], items:menus[0]},
	              {listTitle:titles[1], items:menus[1]},
	              {listTitle:titles[2], items:menus[2]},
	              {listTitle:titles[3], items:menus[3]},
	              {listTitle:titles[4], items:menus[4]}
	             ];
	
	// now I can save all these models to the db and update the screen
	this.db.add('Cafeteria Sprengelstube', listModels, 
			function() {Mojo.Log.info('parsePZH: stored menu');},
	    	function() {Mojo.Log.error('parsePZH: storing menu failed');});
	
	if (this.currentMensa == "Cafeteria Sprengelstube")
		this.dbGetMensaOK(listModels);	
}

SimpleAssistant.prototype.parseHerrenhausen= function(menu) {
	menu = menu.substring(menu.search(/#/), menu.search(/- LEGEND/));
	menu = menu.split(/#/g);
	
	// parse list titles from string
	titles = this.parseListTitles(menu);

	// parse list items from string
	menus = [menu[2].split(/>|\|/g),
	         menu[4].split(/>|\|/g),
	         menu[6].split(/>|\|/g),
	         menu[8].split(/>|\|/g),
	         menu[10].split(/>|\|/g)];
	
	// for each list item we need to fill the header and the menu part
	for (i = 0; i < 5; i++) {
		menus[i] = [
					{header:$L("Eintopf/Tellergericht"), menu:$L(menus[i][1].split(": ")[1])},
					{header:$L("Menü"), menu:$L(menus[i][2].split(": ")[1])},
					{header:$L("Menü fleischlos"), menu:$L(menus[i][3].split(": ")[1])}
	     		];
	}
	

	// stuff together list models
	listModels = [
	              {listTitle:titles[0], items:menus[0]},
	              {listTitle:titles[1], items:menus[1]},
	              {listTitle:titles[2], items:menus[2]},
	              {listTitle:titles[3], items:menus[3]},
	              {listTitle:titles[4], items:menus[4]}
	             ];
	
	// now I can save all these models to the db and update the screen
	this.db.add('Cafeteria Herrenhausen', listModels, 
			function() {Mojo.Log.info('parsePZH: stored menu');},
	    	function() {Mojo.Log.error('parsePZH: storing menu failed');});
	
	if (this.currentMensa == "Cafeteria Herrenhausen")
		this.dbGetMensaOK(listModels);	
}
